Subject: Re: Cygnus Cygwin32 Press Release 1/21/97
From: [email-masked] (Jim Balter)

13 Feb 1997 22:41:24 -0800
Approved: [email-masked]
Distribution: cygnus
Message-ID: <[email-masked]>
References: <[email-masked]>
		<[email-masked]>
		<[email-masked]>
		<[email-masked]>
		<[email-masked]> <[email-masked]>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit
X-Mailer: Mozilla 3.01Gold (WinNT; I)
Original-To: Richard Watts <[email-masked]>
Original-CC: [email-masked]
Original-Sender: [email-masked]

Richard Watts wrote:
> 
> [ jqb: Do you mind if I post this to gnu.misc.discuss (has someone already
> done so ?), and we can pick it up again there ? Is there anyone
>  without access to gnu.misc.discuss ? ]

No, I don't mind.  But for now I'll respond here.
If you want to follow up there, that's fine.

> On Wed 12 February 1997, Jim Balter
> <[email-masked]> wrote:
> 
> >Richard Watts wrote:
> [snip]
> >This is conceptual confusion; it's not a matter of Cygnus claiming
> >rights over code you own, it's a matter of distribution rights.
> 
>  I think it is: cygnus are claiming rights for the rest of the world
> by proxy. The problem doesn't lie in the proprietory vs. free software
> debate per se, but more in the associated problem that linking with
> GPL'd libraries means you have to be very careful not to let even
> non-computer-related trade secrets anywhere near your code (a
> particularly nasty barrister might even argue that the intent of the
> license is that you should upload your modifications to an ftp
> site. If you don't, you're depriving the copyright holder of support
> profits due to increased custom, and are guilty of a criminal offence
> (in the UK, anyway). I don't think this would stand up in court,
> but...).  This is a recognised problem, which is why the LGPL exists
> at all.

Cygnus is taking advantage of the problems with the GPL to make money.  
If the GPL did not make it impossible for programmers working in
the commercial world to use GPL'ed tools, then no one would need to
pay for the Cygnus license.  This is the difference between the
LPGL and GPL+restrictive copyright.  Cygnus has every right to use
this combination, just as they would have the right to not put the
code under the GPL at all.  But it must be clearly understood that,
while Cygnus is allowing you to look at their code, they aren't
allowing you to use it in the real-life commercial world without
paying for it.
 
> >  If your
> >code can't be run without using some piece of GPL software (cygwin.dll,
> >for instance), then your ownership of it does you little.
> 
>  True. There's a grey area here which makes me jumpy: bash shell
> scripts require GPL software, for example. So do a lot of
> programs which rely (intentionally or otherwise) on GNU
> bugs, or on being compiled by gcc. Linux kernel modules are
> a good case in point.

But you need not distribute bash or the Linux kernel to make your
scripts or modules useful.  My point above was overgeneralized;
it only applies to GPL software that isn't ubiquitous on the target
system.  cygwin.dll, for instance.

> I suppose the question is whether a derivative work must necessarily
> contain portions of the original work, or whether it is sufficient
> that the derivative work should only be comprehensible when taken
> together with the original.

The latter certainly does not make something a derivative work.
C programs aren't derivative of a C compiler.

>  The former is clearly the case for books (\cite{concordances, works of
> criticism}), but can be used to subvert the intent of the GPL by
> distributing patches, and it's unclear how the presence of automated
> tools to merge the works interacts with the situation.

If a patch contains a modified line from the program it patches,
it is certainly headed into "derived" territory.  The issue with
literary criticism is "fair use", which a patch would not be an
example of.

> >  You have a
> >choice: sell your code to customers on the condition that they acquire
> >the GPL code code by themselves, or distribute the GPL code along with
> >yours and license your software to any party for free, as the GPL
> >requires.
> 
>  However, this could be said to be more than a little bit silly.

Only to the degree that GPL'ed commercial software is silly.

> It
> indicates that if I build an executable on my machine and ship it to a
> customer site, the whole program must be licensed to
> everyone. However, if I ship the source to a customer site then build
> the executable, I'm safe (or am I ? Is the source a derivative work ?).

Sure you are safe.  I can sell proprietary source code to people who
happen to have obtained gcc or cygwin.dll or whatever.  Why not?  My
code certainly does not become a derived work of cygwin.dll by doing so.
I go back to what I said at the top; it is a matter of *distribution
rights*.

> >Cygnus is now giving you another option: you can distribute cygwin.dll
> >along with your code without having to give your code away, if you
> >pay Cygnus for the privilege.
> 
>  However, all this practically says is that it's the end user who
> has to type `make'. To be frank, I think this is pretty silly...

That's practically saying a whole lot.  People/companies don't buy
software for which they must obtain a build environment elsewhere and
must build themselves.  Now that *is* silly. 

> (in fact, I think 2(b) of the GPL is a load of nonsense and should
> be scrapped, or at least extensively modified. As you say, the
> [L]GPL also has horrible problems with multiple-authorship
> programs).

Well, it has been pointed out that these problems can be avoided
by having people assign ownership.

--
<J Q B>
-
For help on using this list, send a message to
"[email-masked]" with one line of text: "help".